clc
clear all

if (1>0)
    r=sym('r');
	m=sym('m');
	E=sym('E');
    
    Gr=sym('Gr');
	Gm=sym('Gm');
	GE=sym('GE');
    
    g=sym('g');
    
    g=5/3;
    u=m/r;
    e=E/r-u^2/2;
   	p=(g-1)*r*e;
else
    r=sym('r');
	u=sym('u');
	e=sym('e');
	g=sym('g');
        
	m=r*u;
	p=(g-1)*r*e;
	E=r*(e+u^2/2);
end
im=sqrt(-1);

% Conserved Variables
hp=[r;u;e];
h=[r;m;E];
Gh=[Gr;Gm;GE];

% Fluxes
Fp=[m;r*u^2+p;(E+p)*u];
Fh=[m;m^2/r+(g-1)*(E-1/2*m^2/r);...
        (E+(g-1)*(E-1/2*m^2/r))*m/r];

% Lax-Wendroff
for ii=1:1:3;
    for jj=1:1:3;
        tempM=0;
        for kk=1:1:3;
            ele=diff(Fh(ii),h(kk))*diff(Fh(kk),h(jj));
            tempM=tempM+ele;
        end
        M(ii,jj)=simple(tempM);
    end
end

% Gas-Kinetic-Scheme
% vx microscopic velocity
% vy microscopic velocity
% vz microscopic velocity
% x=vx/A^0.5 dimensionless microscopic velocity
% y=vy/A^0.5 dimensionless microscopic velocity
% z=vz/A^0.5 dimensionless microscopic velocity

vx=sym('vx');
vy=sym('vy');
vz=sym('vz');

x=sym('x');
y=sym('y');
z=sym('z');

A=sym('A');
C=sym('C');

psi=[1;A^0.5*x;A*(x^2+y^2+z^2)/2];
eq=A^(3/2)*C*exp(-(x-u/A^0.5)^2-y^2-z^2);

hk(1,1)=simple(int(int(int(psi(1)*eq,x,-inf,+inf),y,-inf,+inf),z,-inf,+inf));
hk(2,1)=simple(int(int(int(psi(2)*eq,x,-inf,+inf),y,-inf,+inf),z,-inf,+inf));
hk(3,1)=simple(int(int(int(psi(3)*eq,x,-inf,+inf),y,-inf,+inf),z,-inf,+inf));
hk=simple(subs(subs(hk,C,r/(A*pi)^(3/2)),A,(4/3)*(E/r-m^2/(2*r^2))));
[hk,h]
o=simple(hk-h)

Fhk(1,1)=simple(int(int(int(A^0.5*x*psi(1)*eq,x,-inf,+inf),y,-inf,+inf),z,-inf,+inf));
Fhk(2,1)=simple(int(int(int(A^0.5*x*psi(2)*eq,x,-inf,+inf),y,-inf,+inf),z,-inf,+inf));
Fhk(3,1)=simple(int(int(int(A^0.5*x*psi(3)*eq,x,-inf,+inf),y,-inf,+inf),z,-inf,+inf));
Fhk=simple(subs(subs(Fhk,C,r/(A*pi)^(3/2)),A,(4/3)*(E/r-m^2/(2*r^2))));
[Fhk,Fh]
o=simple(Fhk-Fh)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Operative formulas for discontinous reconstruction
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

for ii=1:1:3;
	dp(ii,1)=simple(int(int(int(psi(ii)*eq,x,0,+inf),y,-inf,+inf),z,-inf,+inf));
end
%dp=simple(subs(subs(dp,C,r/(A*pi)^(3/2)),A,(4/3)*(E/r-m^2/(2*r^2))));

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

for ii=1:1:3;
	ap(ii,1)=simple(int(int(int(A^0.5*x*psi(ii)*eq,x,0,+inf),y,-inf,+inf),z,-inf,+inf));
end
ap=simple(subs(subs(ap,C,r/(A*pi)^(3/2)),A,(4/3)*(E/r-m^2/(2*r^2))));

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

Ah=(4/3)*(E/r-m^2/(2*r^2));
Ch=r/(Ah*pi)^(3/2);
psih=[1;Ah^0.5*x;Ah*(x^2+y^2+z^2)/2];

for ii=1:1:3;
    for jj=1:1:3;
        corr(ii,1)=Ah^0.5*psih(ii);
        Geq(jj,1)=(diff(eq,h(jj))+diff(eq,A)*diff(Ah,h(jj))+diff(eq,C)*diff(Ch,h(jj)));
        arg = diff(corr(ii),h(jj))*eq + corr(ii)*Geq(jj);
        Rp(ii,jj)=simple(int(int(int(x*( arg ),x,0,+inf),y,-inf,+inf),z,-inf,+inf));
    end
end
Rp=simple(subs(subs(Rp,C,r/(A*pi)^(3/2)),A,(4/3)*(E/r-m^2/(2*r^2))));

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

for ii=1:1:3;
    corr(ii,1)=Ah^0.5*psih(ii);
    arg = 0;
    for kk=1:1:3;
        Geq(kk,1)=(diff(eq,h(kk))+diff(eq,A)*diff(Ah,h(kk))+diff(eq,C)*diff(Ch,h(kk)));
        arg = arg + (diff(corr(ii),h(kk))*eq + corr(ii)*Geq(kk))*Gh(kk);
    end
    bp(ii,1)=simple(int(int(int(x*( arg ),x,0,+inf),y,-inf,+inf),z,-inf,+inf));
end
bp=simple(subs(subs(bp,C,r/(A*pi)^(3/2)),A,(4/3)*(E/r-m^2/(2*r^2))));
